Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 101)
@@ -35,4 +35,145 @@
       {
         // -------------------------------------------------------------------
+        // -----[ next state ]------------------------------------------------
+        // -------------------------------------------------------------------
+        for (uint32_t i=0; i<_param->_nb_context; i++)
+          {
+//             uint32_t x = _param->_link_context_to_decod_unit    [i];
+
+            Tcounter_t inst_all = PORT_READ(in_NB_INST_COMMIT_ALL[i]) + PORT_READ(in_NB_INST_DECOD_ALL [i]);
+//          Tcounter_t inst_mem = PORT_READ(in_NB_INST_COMMIT_MEM[i]) + PORT_READ(in_NB_INST_DECOD_ALL [i]);
+
+            context_state_t state = reg_STATE [i];
+
+            switch (state)
+              {
+              case CONTEXT_STATE_OK              :
+                {
+                  // nothing, wait an event
+                  break;
+                }
+              case CONTEXT_STATE_KO_EXCEP        :
+                {
+                  // Wait end of all instruction
+                  if (inst_all == 0)
+                    state = CONTEXT_STATE_KO_EXCEP_ADDR;
+                  break;
+                }
+              case CONTEXT_STATE_KO_EXCEP_ADDR   :
+                {
+                  // nothing, wait the update of internal register (pc)
+                  break;
+                }
+              case CONTEXT_STATE_KO_MISS_WAITEND :
+                {
+                  // Wait end of all instruction
+                  if (inst_all == 0)
+                    
+//                  state = CONTEXT_STATE_OK; // @@@ TODO : make MISS fast (miss decod)
+                    state = CONTEXT_STATE_KO_MISS_ADDR;
+                  break;
+                }
+              case CONTEXT_STATE_KO_EXCEP_SPR    :
+                {
+                  // nothing, wait the update of internal register (epcr, eear, sr, esr)
+                  break;
+                }
+              case CONTEXT_STATE_KO_MISS_ADDR    :
+                {
+                  // nothing, wait the update of internal register (pc)
+                  break;
+                }
+//               case CONTEXT_STATE_KO_PSYNC        :
+//                 {
+//                   // Wait end of all instruction
+//                   if (inst_all == 0)
+//                     state = CONTEXT_STATE_KO_PSYNC_FLUSH;
+//                   break;
+//                 }
+              case CONTEXT_STATE_KO_PSYNC_FLUSH  :
+                {
+                  // nothing, wait end of flush (ifetch)
+                  if (inst_all == 0)
+//                  state = CONTEXT_STATE_KO_PSYNC_ADDR;
+                    state = CONTEXT_STATE_OK;
+                    
+                  break;
+                }
+              case CONTEXT_STATE_KO_PSYNC_ADDR   :
+                {
+                  // nothing, wait the pc write
+                  break;
+                }
+//               case CONTEXT_STATE_KO_CSYNC        :
+//                 {
+//                   // Wait end of all instruction
+//                   if (inst_all == 0)
+//                     state = CONTEXT_STATE_KO_CSYNC_FLUSH;
+//                   break;
+//                 }
+              case CONTEXT_STATE_KO_CSYNC_FLUSH  :
+                {
+                  // nothing, wait end of flush (all internal structure)
+                  if (inst_all == 0)
+                    state = CONTEXT_STATE_KO_CSYNC_ADDR;
+                  break;
+                }
+              case CONTEXT_STATE_KO_CSYNC_ADDR   :
+                {
+                  // nothing, wait the pc write
+                  break;
+                }
+//               case CONTEXT_STATE_KO_MSYNC        :
+//                 {
+//                   // Wait end of memory instruction
+//                   if (inst_mem == 0)
+//                     state = CONTEXT_STATE_KO_MSYNC_ISSUE;
+//                   break;
+//                 }
+//               case CONTEXT_STATE_KO_MSYNC_ISSUE  :
+//                 {
+//                   // Wait the msync issue
+//                   if (inst_mem != 0)
+//                     state = CONTEXT_STATE_KO_MSYNC_EXEC;
+//                   break;
+//                 }
+              case CONTEXT_STATE_KO_MSYNC_EXEC   :
+                {
+                  // Wait the end of msync
+                  if (inst_all == 0)
+                    state = CONTEXT_STATE_OK;
+                  break;
+                }
+//               case CONTEXT_STATE_KO_SPR          :
+//                 {
+//                   // Wait end of all instruction
+//                   if (inst_all == 0)
+//                     state = CONTEXT_STATE_KO_SPR_ISSUE;
+//                   break;
+//                 }
+//               case CONTEXT_STATE_KO_SPR_ISSUE    :
+//                 {
+//                   // Wait the spr_access issue
+//                   if (inst_all != 0)
+//                     state = CONTEXT_STATE_KO_SPR_EXEC;
+//                   break;
+//                 }
+              case CONTEXT_STATE_KO_SPR_EXEC     :
+                {
+                  // Wait the spr_access execution
+                  if (inst_all == 0)
+                    state = CONTEXT_STATE_OK;
+                  break;
+                }
+
+              default :
+                {
+                  throw ERRORMORPHEO(FUNCTION,toString(_("Context[%d], Unknow state : %s.\n"),i,toString(state).c_str()));
+                }
+              }
+            reg_STATE [i] = state;
+          }
+
+        // -------------------------------------------------------------------
         // -----[ BRANCH_EVENT ]----------------------------------------------
         // -------------------------------------------------------------------
@@ -57,5 +198,5 @@
 
               // priority : miss > excep > spr/sync
-              uint8_t    priority0  = (state == CONTEXT_STATE_KO_MISS)?2:((state == EVENT_TYPE_EXCEPTION)?1:0);
+              uint8_t    priority0  = ((state == CONTEXT_STATE_KO_MISS_ADDR) or (state == CONTEXT_STATE_KO_MISS_WAITEND))?2:((state == EVENT_TYPE_EXCEPTION)?1:0);
               uint8_t    priority1  = 2; // miss
 
@@ -71,5 +212,6 @@
                 {
                   Tcontrol_t dest_val = PORT_READ(in_BRANCH_EVENT_ADDRESS_DEST_VAL[i]);
-                  reg_STATE                  [i] =  CONTEXT_STATE_KO_MISS;
+//                reg_STATE                  [i] =  CONTEXT_STATE_KO_MISS_ADDR;
+                  reg_STATE                  [i] =  CONTEXT_STATE_KO_MISS_WAITEND; //@@@ TODO : make MISS fast (miss decod)
                   reg_EVENT_ADDRESS          [i] =  PORT_READ(in_BRANCH_EVENT_ADDRESS_SRC  [i])+1; // address delay slot
                   reg_EVENT_ADDRESS_EPCR     [i] =  PORT_READ(in_BRANCH_EVENT_ADDRESS_DEST [i]);   // address_next
@@ -107,5 +249,5 @@
               
               // miss > excep > spr/sync
-              uint8_t    priority0  = (state == CONTEXT_STATE_KO_MISS)?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
+              uint8_t    priority0  = ((state == CONTEXT_STATE_KO_MISS_ADDR) or (state == CONTEXT_STATE_KO_MISS_WAITEND))?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
               uint8_t    priority1  = (state == EVENT_TYPE_EXCEPTION)?1:0;
 
@@ -120,4 +262,6 @@
               if (is_valid)
                 {
+                  log_printf(TRACE,Context_State,FUNCTION,"    * is_valid");
+
                   // decod : 
                   // type : csync, psync, msync, spr_access (l.mac, l.maci, l.macrc, l.msb, l.mfspr, l.mtspr), exception (l.sys)
@@ -130,4 +274,6 @@
                     case EVENT_TYPE_EXCEPTION          : 
                       {
+                        log_printf(TRACE,Context_State,FUNCTION,"    * EVENT_TYPE_EXCEPTION");
+
                         state_next = CONTEXT_STATE_KO_EXCEP; 
 
@@ -136,32 +282,44 @@
                     case EVENT_TYPE_SPR_ACCESS         : 
                       {
-                        state_next = CONTEXT_STATE_KO_SPR  ; 
+                        log_printf(TRACE,Context_State,FUNCTION,"    * EVENT_TYPE_SPR_ACCESS");
+
+//                      state_next = CONTEXT_STATE_KO_SPR  ; 
+                        state_next = CONTEXT_STATE_KO_SPR_EXEC; 
                         address++; // take next address
-                        if (is_delay_slot)
-                          throw ERRORMORPHEO(FUNCTION,"SPR access in delay slot, not supported.\n");
+//                         if (is_delay_slot)
+//                           throw ERRORMORPHEO(FUNCTION,"SPR access in delay slot, not supported.\n");
                         break;
                       }
                     case EVENT_TYPE_MSYNC              : 
                       {
-                        state_next = CONTEXT_STATE_KO_MSYNC;
+                        log_printf(TRACE,Context_State,FUNCTION,"    * EVENT_TYPE_MSYNC");
+
+//                      state_next = CONTEXT_STATE_KO_MSYNC;
+                        state_next = CONTEXT_STATE_KO_MSYNC_EXEC;
                         address++;  // take next address
-                        if (is_delay_slot)
-                          throw ERRORMORPHEO(FUNCTION,"SPR access in delay slot, not supported.\n");
+//                         if (is_delay_slot)
+//                           throw ERRORMORPHEO(FUNCTION,"MSYNC in delay slot, not supported.\n");
                         break;
                       }
                     case EVENT_TYPE_PSYNC              :
                       {
-                        state_next = CONTEXT_STATE_KO_PSYNC;
+                        log_printf(TRACE,Context_State,FUNCTION,"    * EVENT_TYPE_PSYNC");
+
+//                      state_next = CONTEXT_STATE_KO_PSYNC;
+                        state_next = CONTEXT_STATE_KO_PSYNC_FLUSH;
                         address++;  // take next address
                         if (is_delay_slot)
-                          throw ERRORMORPHEO(FUNCTION,"SPR access in delay slot, not supported.\n");
+                          throw ERRORMORPHEO(FUNCTION,"PSYNC in delay slot, not supported.\n");
                         break;
                       }
                     case EVENT_TYPE_CSYNC              :
                       {
-                        state_next = CONTEXT_STATE_KO_CSYNC;
+                        log_printf(TRACE,Context_State,FUNCTION,"    * EVENT_TYPE_CSYNC");
+
+//                      state_next = CONTEXT_STATE_KO_CSYNC;
+                        state_next = CONTEXT_STATE_KO_CSYNC_FLUSH;
                         address++;  // take next address
                         if (is_delay_slot)
-                          throw ERRORMORPHEO(FUNCTION,"SPR access in delay slot, not supported.\n");
+                          throw ERRORMORPHEO(FUNCTION,"CSYNC in delay slot, not supported.\n");
                         break;
                       }               
@@ -210,5 +368,5 @@
             
             // miss > excep > spr/sync
-            uint8_t    priority0  = (state == CONTEXT_STATE_KO_MISS)?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
+            uint8_t    priority0  = ((state == CONTEXT_STATE_KO_MISS_ADDR) or (state == CONTEXT_STATE_KO_MISS_WAITEND))?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
             uint8_t    priority1  = 1; // exception
 
@@ -277,5 +435,5 @@
                   
 //                   // miss > excep > spr/sync
-//                   uint8_t    priority0  = (state == CONTEXT_STATE_KO_MISS)?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
+//                   uint8_t    priority0  = ((state == CONTEXT_STATE_KO_MISS_ADDR) or (state == CONTEXT_STATE_KO_MISS_WAITEND))?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
 //                   uint8_t    priority1  = 2; // miss
                   
@@ -323,4 +481,8 @@
                   }
                 case CONTEXT_STATE_KO_MISS_ADDR  :
+//                   {
+//                     reg_STATE [i] = CONTEXT_STATE_KO_MISS_WAITEND; //@@@ TODO : make MISS fast (miss decod)
+//                     break;
+//                   }
                 case CONTEXT_STATE_KO_PSYNC_ADDR :
                 case CONTEXT_STATE_KO_CSYNC_ADDR :
@@ -357,139 +519,4 @@
               reg_STATE [i] = CONTEXT_STATE_OK;
             }
-
-        // -------------------------------------------------------------------
-        // -----[ next state ]------------------------------------------------
-        // -------------------------------------------------------------------
-        for (uint32_t i=0; i<_param->_nb_context; i++)
-          {
-//             uint32_t x = _param->_link_context_to_decod_unit    [i];
-
-            Tcounter_t inst_all = PORT_READ(in_NB_INST_COMMIT_ALL[i]) + PORT_READ(in_NB_INST_DECOD_ALL [i]);
-            Tcounter_t inst_mem = PORT_READ(in_NB_INST_COMMIT_MEM[i]) + PORT_READ(in_NB_INST_DECOD_ALL [i]);
-
-            context_state_t state = reg_STATE [i];
-
-            switch (state)
-              {
-              case CONTEXT_STATE_OK              :
-                {
-                  // nothing, wait an event
-                  break;
-                }
-              case CONTEXT_STATE_KO_EXCEP        :
-                {
-                  // Wait end of all instruction
-                  if (inst_all == 0)
-                    state = CONTEXT_STATE_KO_EXCEP_ADDR;
-                  break;
-                }
-              case CONTEXT_STATE_KO_MISS         :
-                {
-                  // Wait end of all instruction
-                  if (inst_all == 0)
-                    state = CONTEXT_STATE_KO_MISS_ADDR;
-                  break;
-                }
-              case CONTEXT_STATE_KO_EXCEP_ADDR   :
-                {
-                  // nothing, wait the update of internal register (pc)
-                  break;
-                }
-              case CONTEXT_STATE_KO_EXCEP_SPR    :
-                {
-                  // nothing, wait the update of internal register (epcr, eear, sr, esr)
-                  break;
-                }
-              case CONTEXT_STATE_KO_MISS_ADDR    :
-                {
-                  // nothing, wait the update of internal register (pc)
-                  break;
-                }
-              case CONTEXT_STATE_KO_PSYNC        :
-                {
-                  // Wait end of all instruction
-                  if (inst_all == 0)
-//                  state = CONTEXT_STATE_KO_PSYNC_FLUSH;
-                    state = CONTEXT_STATE_KO_PSYNC_ADDR ;
-                  break;
-                }
-//            case CONTEXT_STATE_KO_PSYNC_FLUSH  :
-//              {
-//                // nothing, wait end of flush (ifetch)
-//                break;
-//              }
-              case CONTEXT_STATE_KO_PSYNC_ADDR   :
-                {
-                  // nothing, wait the pc write
-                  break;
-                }
-              case CONTEXT_STATE_KO_CSYNC        :
-                {
-                  // Wait end of all instruction
-                  if (inst_all == 0)
-                    state = CONTEXT_STATE_KO_CSYNC_ADDR ;
-//                  state = CONTEXT_STATE_KO_CSYNC_FLUSH;
-                  break;
-                }
-//            case CONTEXT_STATE_KO_CSYNC_FLUSH  :
-//              {
-//                // nothing, wait end of flush (all internal structure)
-//                break;
-//              }
-              case CONTEXT_STATE_KO_CSYNC_ADDR   :
-                {
-                  // nothing, wait the pc write
-                  break;
-                }
-              case CONTEXT_STATE_KO_MSYNC        :
-                {
-                  // Wait end of memory instruction
-                  if (inst_mem == 0)
-                    state = CONTEXT_STATE_KO_MSYNC_ISSUE;
-                  break;
-                }
-              case CONTEXT_STATE_KO_MSYNC_ISSUE  :
-                {
-                  // Wait the msync issue
-                  if (inst_mem != 0)
-                    state = CONTEXT_STATE_KO_MSYNC_EXEC;
-                  break;
-                }
-              case CONTEXT_STATE_KO_MSYNC_EXEC   :
-                {
-                  // Wait the end of msync
-                  if (inst_mem == 0)
-                    state = CONTEXT_STATE_OK;
-                  break;
-                }
-              case CONTEXT_STATE_KO_SPR          :
-                {
-                  // Wait end of all instruction
-                  if (inst_all == 0)
-                    state = CONTEXT_STATE_KO_SPR_ISSUE;
-                  break;
-                }
-              case CONTEXT_STATE_KO_SPR_ISSUE    :
-                {
-                  // Wait the spr_access issue
-                  if (inst_all != 0)
-                    state = CONTEXT_STATE_KO_SPR_EXEC;
-                  break;
-                }
-              case CONTEXT_STATE_KO_SPR_EXEC     :
-                {
-                  // Wait the spr_access execution
-                  if (inst_all == 0)
-                    state = CONTEXT_STATE_OK;
-                  break;
-                }
-
-              default :
-                {
-                  throw ERRORMORPHEO(FUNCTION,toString(_("Context[%d], Unknow state : %s.\n"),i,toString(state).c_str()));
-                }
-              }
-            reg_STATE [i] = state;
-          }
 
         for (uint32_t i=0; i<_param->_nb_context; ++i)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 101)
@@ -29,7 +29,12 @@
   void instruction_decod               (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod","  * instruction   : decod");
+
 //     instruction_decod_type_0 (inst,param);
 
     uint32_t opcod = range<uint32_t>(inst->_instruction,31,26);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 0][opcod]) (inst,param);
   }
@@ -43,5 +48,10 @@
   void instruction_decod_type_1        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_1","  * instruction   : decod type_1");
+    
     uint32_t opcod = range<uint32_t>(inst->_instruction, 7, 0);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 1][opcod]) (inst,param);
   }
@@ -49,5 +59,10 @@
   void instruction_decod_type_2        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_2","  * instruction   : decod type_2");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction, 7, 0);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 2][opcod]) (inst,param);
   }
@@ -55,6 +70,11 @@
   void instruction_decod_type_3        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_3","  * instruction   : decod type_3");
+
     uint32_t opcod = ((range<uint32_t>(inst->_instruction, 9, 8)<<4) |
 		      (range<uint32_t>(inst->_instruction, 3, 0)));
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 3][opcod]) (inst,param);
   }
@@ -62,5 +82,10 @@
   void instruction_decod_type_4        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_4","  * instruction   : decod type_4");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction,25,21);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 4][opcod]) (inst,param);
   }
@@ -68,5 +93,10 @@
   void instruction_decod_type_5        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_5","  * instruction   : decod type_5");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction,25,21);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 5][opcod]) (inst,param);
   }
@@ -74,5 +104,10 @@
   void instruction_decod_type_6        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_6","  * instruction   : decod type_6");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction, 7, 6);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 6][opcod]) (inst,param);
   }
@@ -80,5 +115,10 @@
   void instruction_decod_type_7        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_7","  * instruction   : decod type_7");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction, 3, 0);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 7][opcod]) (inst,param);
   }
@@ -86,5 +126,10 @@
   void instruction_decod_type_8        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_8","  * instruction   : decod type_8");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction,16,16);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 8][opcod]) (inst,param);
   }
@@ -92,5 +137,10 @@
   void instruction_decod_type_9        (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_9","  * instruction   : decod type_9");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction,25,23);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[ 9][opcod]) (inst,param);
   }
@@ -98,5 +148,10 @@
   void instruction_decod_type_10       (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_10","  * instruction   : decod type_10");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction,25,24);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[10][opcod]) (inst,param);
   }
@@ -104,5 +159,10 @@
   void instruction_decod_type_11       (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_11","  * instruction   : decod type_11");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction, 7, 6);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[11][opcod]) (inst,param);
   }
@@ -110,5 +170,10 @@
   void instruction_decod_type_12       (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_12","  * instruction   : decod type_12");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction, 7, 6);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[12][opcod]) (inst,param);
   }
@@ -116,5 +181,10 @@
   void instruction_decod_type_13       (decod_instruction_t * inst, decod_param_t * param)
   {
+    log_printf(TRACE,Decod,"instruction_decod_type_13","  * instruction   : decod type_13");
+
     uint32_t opcod = range<uint32_t>(inst->_instruction, 7, 6);
+
+    log_printf(TRACE,Decod,"instruction_decod","    * opcod : %d (0x%x)",opcod,opcod);
+
     (* param->_function_decod[13][opcod]) (inst,param);
   }
@@ -122,5 +192,7 @@
   void instruction_illegal             (decod_instruction_t * inst, decod_param_t * param)
   {
-    log_printf(TRACE,Decod,"instruction_illegal","instruction_illegal");
+    log_printf(TRACE,Decod,"instruction_illegal","  * instruction   : illegal");
+
+    msgWarning(_("Instruction \"%.8x\" at address \"%.8x\" is illegal.\n"),inst->_instruction,inst->_address);
 	
     inst->_exception_use = EXCEPTION_USE_ILLEGAL_INSTRUCTION;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/include/Decod_request.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/include/Decod_request.h	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/include/Decod_request.h	(revision 101)
@@ -156,5 +156,5 @@
     0xe1e4f801,x,y,z,
     BRANCH_STATE_NONE,0,BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK,0,0x0, 
-    0,TYPE_ALU,OPERATION_ALU_L_ADD,false, 
+    0,TYPE_ALU,OPERATION_ALU_L_ADDC,false, 
     0,0x00000000,1, 4,1,31,1,SPR_LOGIC_SR_CY_OV,1,15,1,SPR_LOGIC_SR_CY_OV,
     EXCEPTION_USE_RANGE,EVENT_TYPE_NONE));
@@ -192,5 +192,5 @@
     0xa0ecffff,x,y,z,
     BRANCH_STATE_NONE,0,BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK,0, 0x0,
-    0,TYPE_ALU,OPERATION_ALU_L_ADD,false, 
+    0,TYPE_ALU,OPERATION_ALU_L_ADDC,false, 
     1,0xffffffff,1,12,0, 0,1,SPR_LOGIC_SR_CY_OV,1,7 ,1,SPR_LOGIC_SR_CY_OV,
     EXCEPTION_USE_RANGE,EVENT_TYPE_NONE));
@@ -201,5 +201,5 @@
     0xa1110000,x,y,z,
     BRANCH_STATE_NONE,0,BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK,0, 0x0,
-    0,TYPE_ALU,OPERATION_ALU_L_ADD,false, 
+    0,TYPE_ALU,OPERATION_ALU_L_ADDC,false, 
     1,0x00000000,1,17,0, 0,1,SPR_LOGIC_SR_CY_OV,1,8 ,1,SPR_LOGIC_SR_CY_OV,
     EXCEPTION_USE_RANGE,EVENT_TYPE_NONE));
@@ -210,5 +210,5 @@
     0xa2a707bd,x,y,z,
     BRANCH_STATE_NONE,0,BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK,0, 0x0,
-    0,TYPE_ALU,OPERATION_ALU_L_ADD,false, 
+    0,TYPE_ALU,OPERATION_ALU_L_ADDC,false, 
     1,0x000007bd,1, 7,0, 0,1,SPR_LOGIC_SR_CY_OV,1,21,1,SPR_LOGIC_SR_CY_OV,
     EXCEPTION_USE_RANGE,EVENT_TYPE_NONE));
@@ -358,5 +358,5 @@
     0x23000000,x,y,z,
     BRANCH_STATE_NONE,0,BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK,0, 0x0,
-    0,TYPE_SPECIAL,OPERATION_SPECIAL_L_CSYNC,false,
+    0,TYPE_MEMORY,OPERATION_MEMORY_SYNCHRONIZATION,false,
     0,0  ,0,0 ,0,0 ,0,0                 ,0,0 ,0,0                 ,
     EXCEPTION_USE_NONE,EVENT_TYPE_CSYNC));
@@ -498,5 +498,5 @@
     BRANCH_STATE_NONE,0,BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK,1, z, // branch_address_dest can be determined if BRANCH_STATE != NONE (also : previous prediction)
     0,TYPE_BRANCH,OPERATION_BRANCH_L_JALR,false,
-    0,0   ,0,0 ,1,20,0,0,1,9 ,0,0,
+    1,z+1,0,0 ,1,20,0,0,1,9 ,0,0,
     EXCEPTION_USE_NONE,EVENT_TYPE_NONE));
     SEQ;
@@ -605,5 +605,5 @@
     0x22000000,x,y,z,
     0,0,0,0,0,0,
-    TYPE_SPECIAL,OPERATION_SPECIAL_L_MSYNC,false,
+    TYPE_MEMORY,OPERATION_MEMORY_SYNCHRONIZATION,false,
     0,0, 0,0, 0,0, 0,0, 0,0, 0,0,
     EXCEPTION_USE_NONE,EVENT_TYPE_MSYNC));
@@ -713,5 +713,5 @@
     0x22800000,x,y,z,
     0,0,0,0,0,0,
-    TYPE_SPECIAL,OPERATION_SPECIAL_L_PSYNC,false,
+    TYPE_MEMORY,OPERATION_MEMORY_SYNCHRONIZATION,false,
     0,0, 0,0, 0,0, 0,0, 0,0, 0,0,
     EXCEPTION_USE_NONE,EVENT_TYPE_PSYNC));
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/src/test.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/src/test.cpp	(revision 101)
@@ -99,4 +99,5 @@
 //   ALLOC1_SC_SIGNAL( in_PREDICT_CAN_CONTINUE               ," in_PREDICT_CAN_CONTINUE               ",Tcontrol_t         ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL( in_CONTEXT_DECOD_ENABLE               ," in_CONTEXT_DECOD_ENABLE               ",Tcontrol_t         ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_CONTEXT_DEPTH_VAL                  ," in_CONTEXT_DEPTH_VAL                  ",Tcontrol_t         ,_param->_nb_context);
   ALLOC1_SC_SIGNAL( in_CONTEXT_DEPTH                      ," in_CONTEXT_DEPTH                      ",Tdepth_t           ,_param->_nb_context);
   ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_VAL                  ,"out_CONTEXT_EVENT_VAL                  ",Tcontrol_t         );
@@ -178,4 +179,5 @@
 //   INSTANCE1_SC_SIGNAL(_Decod, in_PREDICT_CAN_CONTINUE               ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod, in_CONTEXT_DECOD_ENABLE               ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Decod, in_CONTEXT_DEPTH_VAL                  ,_param->_nb_context);
   for (uint32_t i=0; i<_param->_nb_context; i++)
     if (_param->_have_port_depth)
@@ -221,4 +223,7 @@
 
   LABEL("Loop of Test");
+
+  for (uint32_t i=0; i<_param->_nb_context; i++)
+    in_CONTEXT_DEPTH_VAL [i]->write(1);
 
   for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
@@ -475,4 +480,5 @@
   
   delete []  in_CONTEXT_DECOD_ENABLE               ;
+  delete []  in_CONTEXT_DEPTH_VAL                  ;
   delete []  in_CONTEXT_DEPTH                      ;
   
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/include/Decod.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/include/Decod.h	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/include/Decod.h	(revision 101)
@@ -120,4 +120,5 @@
     // ~~~~~[ Interface : "context" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   public    : SC_IN (Tcontrol_t         )  **  in_CONTEXT_DECOD_ENABLE               ;//[nb_context]
+  public    : SC_IN (Tcontrol_t         )  **  in_CONTEXT_DEPTH_VAL                  ;//[nb_context]
   public    : SC_IN (Tdepth_t           )  **  in_CONTEXT_DEPTH                      ;//[nb_context]
 										     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod.cpp	(revision 101)
@@ -103,4 +103,5 @@
 	    if (_param->_have_port_depth)
 	    sensitive << (*(in_IFETCH_BRANCH_UPDATE_PREDICTION_ID [i]));
+	    sensitive << (*(in_CONTEXT_DEPTH_VAL                  [i]));
 	    if (_param->_have_port_depth)
 	    sensitive << (*(in_CONTEXT_DEPTH                      [i]));
